var version = "1.1.0";
function trim( text ) 
{
  return (text || "").replace( /^\s+|\s+$/g, "" );
}
function isEmpty(o)
{
	var s = typeof o;
	return s == "undefined" || o == null || (s == "string" && o.length == 0);
}
function appendList(s)
{
  ObjList[ObjListCount] = s;
  ObjListCount++;
}
function reportScriptError(e)
{
  var error = "desc:"+e.description+"\nmsg:"+e.message+"\nname:"+e.name+"\nNO:"+e.number;
  var message = e.message;
  if(window.external.callExternal)
  {
    ret = window.external.callExternal("reportScriptError",error,message);//
  }
  else
      
  {
  }
}
function getObject(obj,tn)
{
  var i,all = obj.childNodes,t,n,v;
  //alert("all="+all+",l="+all.length);
  //if(isEmpty(all))
  //  return null;
  for(i = 0;i < all.length;i++)
  {
  	if(isEmpty(all[i].tagName))
  	  continue;
  	t = all[i].tagName.toLowerCase();
  	if(t == "param" && !isEmpty(all[i].name))
  	{
  	  n = all[i].name.toLowerCase();
  	  if(n == "movie" || n == "src")
  	  {
  	  	v = all[i].value;
  	  	//alert(all[i].outerHTML+"v="+v);
  	  	if(!isEmpty(v))
        	return s = tn+"::src::"+v;
  	  }
  	}
    else if(t == "embed")
    {
      v = all[i].src;
  	  alert(all[i].outerHTML+"v="+v);
  	  if(!isEmpty(v))
      	return s = tn+"::src::"+v;
    }
  }
  return null;
}
function getApplet(obj,tn)
{
  var s = null;
  //alert("obj.tagName="+obj.tagName.toLowerCase());
  if(!isEmpty(obj.src))
  {
    s = tn+"::src::"+obj.src;
  }
  else if(!isEmpty(obj.code))
  {
    s = tn+"::code::"+obj.code;
  }
  else if(obj.tagName.toLowerCase() == "object")
  {
  	s = getObject(obj,tn);
  }
  //s = tn+"\n"+obj.outerHTML+"\n\n";
  return s;
}
function retriveCollections(colls,type,tn)
{
  var i,len,s;
  //s = "length::"+tn+"::"+colls.length;
  //appendList(s);
  for(i = 0;i < colls.length;i++)
  {
  	s = null;
  	switch(type)
  	{
  	  case 1:	// src/code
  	    s = getApplet(colls[i],tn);
  	  break;
  	  case 0:	// src
  	  default:
  	    if(!isEmpty(colls[i].src))
  	    {
	      s = tn+"::size::"+colls[i].fileSize+"::src::"+colls[i].src;
  	    }
  	  break;
  	  case 2:	// href
	    s = tn+"::href::"+colls[i].href;
  	  break;
  	  case 3:	// scripts/src
  	  	if(!isEmpty(colls[i].src))
  	  	  s = tn+"::src::"+colls[i].src;
	    //else
  	  	//  s = tn+"::str::"+colls[i].outerHTML;
  	  break;
  	  case 4:	// src
  	  	if(!isEmpty(colls[i].src))
  	  	  s = tn+"::src::"+colls[i].src;
  	  break;
  	  case 5:	// styleSheets/href
  	  	if(!isEmpty(colls[i].href))
  	  	  s = tn+"::href::"+colls[i].href;
	    //else
  	  	//  s = tn+"::str1::"+colls[i].outerHTML;
  	  break;
  	}
  	if(s != null)
  	  appendList(s);
  }
}
function retriveDocument(doc)
{
  try 
  {
    var i,len,s;
    if(typeof doc == "undefined" || doc == null)
      return;
      
    s = "document::"+doc.parentWindow.name+"::"+doc.URL;
    appendList(s);
    // 0.get images
    retriveCollections(doc.images,0,"img");
    // 1.get applets
    retriveCollections(doc.applets,1,"applet");
    // 2.get links
    retriveCollections(doc.links,2,"a");
    // 3.get scripts
    retriveCollections(doc.scripts,3,"script");
    // 4.get embeds
    retriveCollections(doc.embeds,4,"embed");
    // 5.get styleSheets
    //retriveCollections(doc.styleSheets,4,"css");
    // get Frames
    len = doc.frames.length;
    if(len <= 0)
      return;
    for(i = 0;i < len;i++)
    {
    	if(doc.frames[i] == null || doc.frames[i].document == doc)
    	  continue;
    	retriveDocument(doc.frames[i].document);  
    }
  } 
  catch (e) 
  {
  	reportScriptError(e);
  }   
  
}
function updateDocumentList()
{
  if(window.external.callExternal)
  {
    ret = window.external.callExternal("updateDocumentList",ObjList,ObjListCount);//
  }
  else
      
  {
  }
}

var ObjList = new Array();
var ObjListCount = 0;

retriveDocument(document);
updateDocumentList();

